#########################################################################
#									#
#	MIDAS General sort package					#
#									#
#	File:		soc.tcl (sort control)				#
#									#
#	Author(s):	Janet Sampson/John Cresswell			#
#									#
#	Last revision:	04/07/97					#
#									#
#########################################################################

set frame SOC

set icontitle "Run"

if { ![info exists env(MTsortVersion)]} {set mtsortversion ""} {set mtsortversion "$env(MTsortVersion)"} 

# Following may be configured explicitly if this code is not appropriate ...

if { ![info exists env(MTSORTBASE)] } {set env(MTSORTBASE) $env(MIDASBASE)/MTsort}

if { ![info exists env(MTSORTDIRPOSTFIX)] } {
    switch $env(os) {
	SunOS    {
	    switch -glob $env(machine) {
		i86pc   {set env(MTSORTDIRPOSTFIX) "_SunOSx86"}
		default {set env(MTSORTDIRPOSTFIX) "_SunOS"}
	    }
	}
	Linux  {
	    set kernel [exec uname -r]
	    switch -glob $kernel {
		2.4.*    -
		2.5.*    -
		2.6.*   {set env(MTSORTDIRPOSTFIX) "_Linux"}
		default {set env(MTSORTDIRPOSTFIX) "_Linux"}
	    }
	    switch -glob $env(machine) {
		i*86   {set env(MTSORTDIRPOSTFIX) "_Linux"}
		*64    {set env(MTSORTDIRPOSTFIX) "_Linux64"}
		default {set env(MTSORTDIRPOSTFIX) "_Linux"}
	    }
	}
	default {set env(MTSORTDIRPOSTFIX) ""; set-footer "Warning MTSORTPOSTFIX set to Null"}
    }
}

set mtpath $env(MTSORTBASE)/bin$env(MTSORTDIRPOSTFIX)$mtsortversion
if {[string first $mtpath [set env(PATH)]] == -1} {
    set env(PATH) $mtpath:[set env(PATH)]
}
set mtlibpath $env(MTSORTBASE)/lib$env(MTSORTDIRPOSTFIX)$mtsortversion
if {[string first $mtlibpath [set env(LD_LIBRARY_PATH)]] == -1} {
    set env(LD_LIBRARY_PATH) $mtlibpath:[set env(LD_LIBRARY_PATH)]
}

# End of configurable section

set sortversion [exec cat $env(MTSORTBASE)/tcl/mtsortversion.tcl]

set frametitle "MTsort Run Window [set sortversion]"

set comtitle "MTsort Scheduler"
set com_icontitle "Scheduler"
set comprogram {MTsortSchedule -t0 -l0 -d$basedir; if ( \-e $basedir/.zapwindow) exit;}
set execcomwindow "exec nohup cmdtool -M 10000000 -WG 650x280-0+0 -Wl \"$comtitle\" -WL \"$com_icontitle\" -WI \"$env(MTSORTBASE)/tcl/bitmaps/sort.icon\" -I \"[concat $comprogram]\" /bin/csh -f &"

set z [catch {exec uname} ArchType]

if {$z==0} {
    if {$ArchType == "Linux"} {
	set z [catch {exec which cmdtool} m]
	if {$z} {
	    set comprogram {setenv LD_LIBRARY_PATH [set env(LD_LIBRARY_PATH)];MTsortSchedule -t0 -l0 -d$basedir; if (! \-e $basedir/.zapwindow) sleep 1000;}
	    set execcomwindow "exec nohup xterm -sb -sl 10000 -geometry 105x20-0+0 -title \"$comtitle\" -e csh -cf \"[concat $comprogram]\" &"
	}
    }
}

#set currentversion "[exec cat $env(MTSORTBASE)/tcl/sos-version.tcl] [set ArchType]"
set currentversion [exec cat $env(MTSORTBASE)/tcl/sos-version.tcl]
#Fix separate versioning for 64bit OS
switch $env(os) {
    Linux  {
	switch -glob $env(machine) {
	    i*86   {}
	    *64    {set currentversion [set currentversion][set env(MTSORTDIRPOSTFIX)]}
	    default {}
	}
    }
}

set execpid 0

set debug 0
set iloop 0
set footer ""
set sortprogstrings {'' '' ''}
set so_mtime ""

set printblockmenustrings {
    "input:  128 bytes"
    "input:  512 bytes"
    "input:  all"
    "input:  current"
    "output: 128 bytes"
    "output: 512 bytes"
    "output: all"
    "input:  formatted events"
    "output: formatted events"
    }
set debugmenustrings {
    "Event level 0"
    "Event level 1"
    "Event level 2"
    "Event level 3"
    "Event level 4"
    "Event level 5"
    "Scheduler on"
    "Scheduler off"
    }
set sortlogmenustrings {
    "last  10 lines"
    "last  50 lines"
    "last 100 lines"
    "last 200 lines"
    "all"
    }
set sortlogmenuvalues { 10 50 100 200 0 }

set specoption 0
set specstyle "new"
set specstyles { "new" "old" "continue" }
set spectrumoptionstrings {
    "Delete/Recreate spectra  "
    "Reload from Disc spectra "
    "Continue with shm spectra"
}

set spectramenustrings {
    "Save spectra"
    "Delete spectrum segments"
   }

set handlerdir $env(MTSORTBASE)/lib$env(MTSORTDIRPOSTFIX)$mtsortversion

set inhandlerprefix "MTsortInput"
set outhandlerprefix "MTsortOutput"

set inhandlerdefault "EurogamTape"
set outhandlerdefault "Null"

set ihselected 1

set MAXOUTSTREAMS 4

set outHandlerEnable(1) 1
for {set s 1} {$s <= $MAXOUTSTREAMS} {incr s} {
    set outHandlerEnable($s) 0
    set ohselected($s) 4
}

set inhandlerlist {}
set outhandlerlist {}

set ihstatus "Unknown"
set ohstatus "Unknown"

set filelist {}

set ohchoice {x y z}
set autochoice { \
	"keep gain coefficients fixed" \
	"invalidate channel -- set gain coefficients to (-1.0 0.0 0.0)" }
set specpath ""
set online 0
set remote 0

#------------------------------------------------------------------------------
   
set expr {}

set setupstatus "Unknown"
set iloop 0

set sortdirpath $env(HOME)/sortdirs
set sortprogram ""

set autogainstyle 0
set autogainchoices(0) "keep gain coefficients fixed"
set autogainchoices(1) "invalidate channel -- set gain coefficients to (-1.0 0.0 0.0)"

set passthrough 0
set keepwindow 0
set eventpause 0

set dirlisttype 0
set started 0

set basedir ""

set runstate 0
set spec_change 1
set prog_change 0
set input_change 0
set output_change 0
set event_change 0

set badcent ""

#------------------------------------------------------------------------------

proc optionMenu {w f varName args} {
    menubutton $w -textvariable $varName -indicatoron 1 -menu $w.menu \
	    -relief raised -bd 2 -padx 4p -pady 4p -highlightthickness 2 \
	    -anchor c -height 1 -width 20
    menu $w.menu -tearoff 0
    foreach i $args {
	$w.menu add command -label $i -command [list set $varName $i]
        }
    return $w.menu
    }

#------------------------------------------------------------------------------

proc click-quit f {
   global env debug started
   if {$debug} {puts stderr "click-quit with argument \{$f\}" }
   destroy-frame $f
   set started 0
}

proc click arg {
   global debug
   if {$debug} {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$f=="ER"} {cleanup-frame; return}
   if {$c==":quit"} {click-quit $f; return}
   switch -glob $w {

      INPUT-HANDLER          {click-input-handler $v}
      INPUT-HANDLER-SETUP    {click-input-handler-setup}

      OUTPUT-HANDLER*        {click-output-handler $w $v}
      OUTPUT-SETUP*          {click-output-handler-setup $w}
      OUTPUT-ENABLE*         {click-output-handler-enable $w $v}

      SORT-PROGRAM           {click-sort-program $v}
      PAUSE-OPTION           {click-pause-option $v}

      GO                     {click-go}
      STOP                   {click-stop}
      PAUSE                  {click-pause}
      RESUME                 {click-resume}
      RELOAD                 {click-reload}
      SORTEXIT               {click-sortexit}
      EXIT                   {click-exit}

      AUTOGAIN-OPTION        {click-autogain-option $v}
      PASS-OPTION            {click-passthrough-option $v}
      EXIT-OPTION            {click-keepwindow-option $v}
      SPECTRUM-OPTION        {click-spectrum-option $v}

      SAVE-SPECTRA           {click-save-spectra}
      DISPLAY-SPECTRA        {click-display-spectra}
      DELETE-SPECTRA         {click-delete-spectra}
      SETUP-FRAME            {click-setup-frame}
      SPECTRUM-PATH          {click-spectrum-path $v}

      STATISTICS             {click-statistics-window}
      PRINT-BLOCK            {click-print-block $v}
      DEBUG                  {click-debug $v}
      SHOW-SORTLOG           {click-show-sortlog $v}
      SPECTRA                {click-spectra $v}
      VARIABLES              {click-variables}
      MYHELP                   {click-help}
      REFRESH                {click-refresh}

      DISMISS                {click-dismiss-formatted-events}
      PRINT                  {click-print-formatted-events}
      SAVE                   {click-save-formatted-events}

      default                {puts stdout $arg}
   }
}

proc make-frame {} {
   global debug env eventpause
   global autochoice passthrough keepwindow
   global inhandlerlist ihselected ihstatus inhandlermenustrings
   global outhandlerlist ohselected ohstatus outHandlerEnable MAXOUTSTREAMS
   global sortprogstrings sortprogram specpath
   global printblockmenustrings debugmenustrings sortlogmenustrings
   global specstyle specstyles spectrumoptionstrings spectramenustrings

  set vx1 230
  set vx2 20c
  set vx3 320
  set vx4 490
  set bwid 18
  set mwid 18

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/sort" \
      :icon-name "[self icon-title]" :resize F
#    [:path [self frame-name]] configure -background wheat

    :container HANDLERS :layout T :anchor N :padx 5 :pady 1 :w 630

    :panel OUTPUT :relief R :layout R :padx 3 :pady 5 :ipadx 2 :ipady 3 :fill NONE
    :layout H; :row-gap 11; :col-gap 10

    for {set s 1} {$s <= $MAXOUTSTREAMS} {incr s} {
	:choice-stack OUTPUT-HANDLER$s :label "Output$s" \
	    :strings [ list XXXXXXXXXXXXXXXXX] :bold T
	:button OUTPUT-SETUP$s :label "Setup" :w 4
#	:checkbox OUTPUT-ENABLE$s :label "" :value $outHandlerEnable($s)
	:modify OUTPUT-HANDLER$s :strings $outhandlerlist :value $ohselected($s)
	:next-row T
    }
#      :text OUTPUT-STATUS :label "Status:" :value "Unknown" :bold T :x $vx3 :w 18
#      [:path OUTPUT-STATUS].entry configure -bd 0

    :panel INPUT :relief R :layout T :padx 3 :pady 3 :ipadx 2 :ipady 2 :fill NONE
    :layout H; :row-gap 10; :col-gap 10

      :choice-stack INPUT-HANDLER :label "Input " :menu [list XXXXXXXXXXXXXXXXXX] :bold T
      :button INPUT-HANDLER-SETUP :label "Setup" :w 4
      :modify INPUT-HANDLER :menu $inhandlermenustrings
    [:path INPUT-HANDLER].message configure -text [lindex $inhandlerlist $ihselected]
#     :next-row T
#      :text INPUT-HANDLER-STATUS :label "Status:" :value "Unknown" :bold T :w 18
#      [:path INPUT-HANDLER-STATUS].entry configure -bd 0
     :next-row T
      :checkbox PASS-OPTION :label "Pass through option" :value $passthrough :valuex 150

    :panel EVENT :relief R :layout L :padx 3 :pady 3 :ipadx 2 :ipady 2 :fill NONE
    :layout H; :row-gap 10; :col-gap 10
    :choice-stack SORT-PROGRAM :label "Sort  " \
       :strings [ list XXXXXXXXXXXXXXXXXX] :bold T
    :button SETUP-FRAME :label "Setup" :w 4
    :modify SORT-PROGRAM :strings $sortprogstrings :value [lsearch $sortprogstrings $sortprogram]
    
    :next-row T
    :checkbox PAUSE-OPTION :label "Pause before each event" :value $eventpause :valuex 150
     :button RESUME :label Resume :w 4 :padx 0 :x 255


    :container THEREST :layout T :anchor N

  :panel OPTIONS  :layout T :padx 10 :pady 5
     :layout H; :row-gap 15; :col-gap 10
      :choice-stack AUTOGAIN-OPTION :label "Bad autogain centroids:" \
         :valuex $vx2 :strings $autochoice :value 0
#      :button DELETE-SPECTRA :label "Delete Spectrum Segments" :x 465
      :checkbox EXIT-OPTION :label "Keep Scheduler window" :value $keepwindow :valuex 330
     :next-row T
      :button GO   :label Go :w 4 :x 100
      :button STOP :label Stop :w 4 :padx 0
#      :button PAUSE :label Pause :w 4 :padx 0
      :button RELOAD :label "Sort Reload" :w 8 :padx 0
      :button SORTEXIT :label "Sort Exit" :w 8 :padx 0
      :text RUN-STATUS :label "Status:" :value "" :bold T :w 18
      [:path RUN-STATUS].entry configure -bd 0
#      :button SAVE-SPECTRA :label "Save spectra" :x 425
      :button EXIT :label Exit :w 6 :padx 0 :x 573
     :next-row T
#      :checkbox SPECTRUM-OPTION :label "Delete/recreate spectra:" :value 1 :valuex $vx2
      set c [lsearch $specstyles $specstyle]
      :choice-stack SPECTRUM-OPTION :label "" :strings $spectrumoptionstrings :value $c
      :text SPECTRUM-PATH :label "Spectrum Path:" :valuex 13c \
         :value $specpath :w 41
      :button DISPLAY-SPECTRA :label "Display spectra" :w 12
     :next-row T
  :panel BUTTONS  :layout T :padx 10 :pady 5
     :layout H; :row-gap 15; :col-gap 6
      :button STATISTICS :label "Statistics"
      :menubutton PRINT-BLOCK :label "Print block" :strings $printblockmenustrings
      :menubutton DEBUG :label "Debug" :strings $debugmenustrings
      :menubutton SHOW-SORTLOG :label "Show sortlog" :strings $sortlogmenustrings
      :menubutton SPECTRA :label "Spectra" :strings $spectramenustrings
      :button VARIABLES :label "Variables"
      :button MYHELP :label "Help" :w 6
      :button REFRESH :label "Refresh" :w 8
   :panel LOG  :layout T :padx 10 :pady 5
     :layout V; :row-gap 2; :col-gap 20
      :message SORTLOG-HEADER :label "S O R T    M E S S A G E S" :bold F \
             :valuex 60c
      :galley SORTLOG :rows 10 :cols 101 :x 0 :deaf T

    bind [:path STATISTICS] <Button-3>  {click-statistics-footer}

  :show F
   set z [catch {wm geometry [self frame-name] -0-10} m]
   if {$z} {set z [catch {wm geometry . -0-10} m]}
   update
   bring-to-front [self frame-name]
}

proc init-sort-frame {} {
   global debug
   global errorCode
   global started
   global sortdirpath specstyle env
   global specpath
   global dirlisttype
   if {$debug} {puts stderr "init-sort-frame"}
   set started 1
   set specstyle "new"

   if {$debug} {puts stderr "sort programs path=$sortdirpath"}

# set default spectrum path from environment variable if no sort is
# running, else from previous value saved in file ~/sortdirs/.specpath
    if {[file exists $sortdirpath/.specpath]} {
	set specpath [exec cat $sortdirpath/.specpath]
    } { 
	set z [catch {get-eg-option mtsort-spectrum-path} m]
	if {!$z} {set specpath $m} {set specpath ""}
    }
    set env(SORTSPECPATH) $specpath

   read-handler-directory
   read-sortprograms
  }

proc check-processes {} {
   global debug
   global env
   if {$debug} {puts stderr "check-processes"}

   set num_init_errors 0

   set resources {}
   set specservernames {}
   set z [catch {set exp $env(EXPERIMENTDIR)} m]
   if {$z==0} {
      set z [catch {eg "(experiment ?resources)"} m]
      if {$z==0} {
         set resources $m
         set specservernames [make-spec-resource-list $resources]
         if {[llength $specservernames]==0} {
            set absent_proc1 "   no spectrum server claimed"
            incr num_init_errors
            } \
         else \
            {set absent_proc1 ""}
         } \
      else {
         set absent_proc1 "   no experiment connected"
         incr num_init_errors
         }
     } \
   else {
     set absent_proc1 "   no experiment connected"
     incr num_init_errors
     }

   if {$debug} {puts stderr "num_init_errors=$num_init_errors"}
   case $num_init_errors {
      {1} {display-midas-error-report self "" \
                   "Sort initialisation error:\n" $absent_proc1}
      default {}
      }

   }

proc fopen {name attr} {
    set err [catch {set f [open $name $attr] } m]
    if {$err} {
	set f 0
#	display-midas-error-report self "" $m
    }
    return $f
}

proc isComment? {s} {
    if { $s =="" } {
	set b 1
    } else {
	set b [expr { [string index $s 0]=="#" } ]
    }
    return $b
}

proc read-file {f} {
    set buf ""
    set fp [fopen $f r]
    if {$fp==0} return ""
    while 1 {
	set t [gets $fp]
	if {[eof $fp]} {break}
	if { ! [isComment? $t] } { lappend buf $t }
    }
    close $fp
    return $buf
}
proc format-runfile {r} {
   scan $r "%s %s %d %d" s1 s2 i1 i2
   set r [format "%6s %-30s %12d %12d" $s1 $s2 $i1 $i2]
   return $r
   }

proc read-set-runfiles {stream} {
    global basedir

    set runfilelist {}
    set r [read-file $basedir/.outruninfo$stream]
    if {$r!=""} {
	foreach l $r {
	    set f [format-runfile $l]
	    lappend runfilelist $f
	}
    }
    set i 1
    foreach f $runfilelist {
	set z [mtsort $basedir "o runinfo $stream $i $f" m 1]
	incr i
    }
}

proc repaint {} {
   global debug specpath sortprogstrings sortprogram nthsortprog
   global passthrough keepwindow eventpause
   :modify SORT-PROGRAM :strings $sortprogstrings \
      :value [lsearch $sortprogstrings $sortprogram]
   :modify SPECTRUM-PATH :value $specpath
   :modify PASS-OPTION :value $passthrough
   :modify PAUSE-OPTION :value $eventpause
   :modify EXIT-OPTION :value $keepwindow
   check-handlers
   paint-handlers
   read-runstatus
   }
                 
proc saveinhandler h {
    global inhandlerdefault
    set inhandlerdefault $h
    set-eg-option mtsort-input-handler $inhandlerdefault
    edit-defaults mtsort-input-handler "set-eg-option mtsort-input-handler $inhandlerdefault"
}

proc saveouthandler {s h} {
    global outhandlerdefault
    set outhandlerdefault $h
    set-eg-option mtsort-output-handler$s $outhandlerdefault
    edit-defaults mtsort-output-handler$s "set-eg-option mtsort-output-handler$s $outhandlerdefault"
}

proc make-inhandler-menu {inlist} {
    global inhandlerlist inhandlers inhandlermenustrings

    set hlist ""
    foreach hn $inlist {
	if {$hn != ""} {
	    lappend hlist [extract-handler $hn]
	}
    }
    set inhandlers [lsort -index 0 $hlist]
    
    set inhandlerlist ""
    set hname ""
    set htypes ""
    set handlers ""
    foreach han $inhandlers {
	lappend inhandlerlist [first $han][second $han]
	if {[first $han] == $hname} {
	    append htypes "[second $han] "
	} {
	    if {$htypes != ""} {
		if {[llength $htypes] == 1} {
		    lappend handlers "$hname$htypes"
		} {
		    lappend handlers "$hname $htypes"
		}
	    }
	    set hname [first $han]
	    set htypes "[second $han] "
	}
    }

    if {$htypes != ""} {
	if {[llength $htypes] == 1} {
	    lappend handlers "$hname$htypes"
	} {
	    lappend handlers "$hname $htypes"
	}
    }

    set inhandlermenustrings $handlers
}

proc make-handler-list {} {
   global debug inhandlerprefix outhandlerprefix
   global inhandlerlist outhandlerlist
   global ihselected ohselected filelist
   if {$debug>2} {puts stderr "make-handlerlist: filelist=$filelist"}

   set inlist {}; set handlercount 0
   foreach p $filelist {
      set t [first $p]
      if { [string first $inhandlerprefix $t]==0} {
	  set t2 [expr [string first ".so" $t] -1]
	  if {[string length $t] != [expr $t2 +4]} continue
         lappend inlist [string range $t [string length $inhandlerprefix] $t2]
         incr handlercount
         }
      }
    make-inhandler-menu $inlist
    if {$debug>2} {puts stderr "...inhandlerlist=$inhandlerlist"}

   set outhandlerlist {}; set handlercount 0

   foreach p $filelist {
      set t [first $p]
      if { [string first $outhandlerprefix $t]==0} {
	  set t2 [expr [string first ".so" $t] -1]
	  if {[string length $t] != [expr $t2 +4]} continue

	  set ff [string range $t [string length $outhandlerprefix] $t2]
	  set ll [string length $ff]
#	  for {set i $ll} {$i < 25} { incr i} {append ff " "}

         lappend outhandlerlist $ff
         incr handlercount
         }
      }
   set outhandlerlist [lsort $outhandlerlist]
   
   lappend outhandlerlist ""
   if {$debug>2} {puts stderr "...outhandlerlist=$outhandlerlist"}
   }

proc read-handler-directory {} {
   global handlerdir filelist
   set z [catch {eg "(directory :path '$handlerdir' ?files)"} m]
   if {$z!=0} {
       display-midas-error-report self $m \
	   "Attempting to read directory" $handlerdir
       puts "Attempting to read directory $handlerdir"
       error $m
   }

   set filelist $m
   make-handler-list
   }

proc check-handlers {} {
   global basedir 
   global inhandlerlist outhandlerlist
   global inhandlerprefix outhandlerprefix outhandlerdefault
   global ihselected ohselected MAXOUTSTREAMS
   global ihstatus ohstatus

   set m ""
   set z [mtsort $basedir "i handler ?" m 1]
    if {$z} {
      def-inhandler
      set handlerloaded ""
      set-footer $m
       return
    } { 
	set i [string last $inhandlerprefix $m]
	if {$i != -1} {
	    set handlerloaded [string range $m [expr $i + [string length $inhandlerprefix]] end]
	    set ihselected [lsearch $inhandlerlist $handlerloaded]
	    if {$ihselected == -1} {def-inhandler}
	}
    }

    for {set stream 1} {$stream <= $MAXOUTSTREAMS} {incr stream} {
	set z [mtsort $basedir "o handler $stream ?" m 1]
	if {$z} {
	    def-outhandler $stream
	    set handlerloaded ""
	    set-footer $m
	    return
	} else { 
	    set i [string last $outhandlerprefix $m]
	    if {$i != -1} {
		set handlerloaded [string range $m [expr $i + [string length $outhandlerprefix]] end]
		if {$handlerloaded == ""} {set handlerloaded $outhandlerdefault}
		set ohselected($stream) [lsearch $outhandlerlist $handlerloaded]
		if {$ohselected($stream) == -1} {def-outhandler $stream}
	    }
	}
    }
}
    
proc paint-handlers {} {
   global basedir outhandlerlist
   global inhandlerlist ihselected ohselected MAXOUTSTREAMS
   global ihstatus ohstatus outHandlerEnable
# input handler...
    [:path INPUT-HANDLER].message configure -text [lindex $inhandlerlist $ihselected]
   set status ""
   set z [mtsort $basedir "i state" status 1]
    if {$z==0} {set ihstatus $status} {return}
#   :modify INPUT-HANDLER-STATUS :value $ihstatus

# output handler...
    for {set stream 1} {$stream <= $MAXOUTSTREAMS} {incr stream} {
#	:modify OUTPUT-ENABLE$stream :value $outHandlerEnable($stream)
	:modify OUTPUT-HANDLER$stream :strings $outhandlerlist :value $ohselected($stream)
    }

   set z [mtsort $basedir "o state" status 1]
    if {$z==0} {set ohstatus $status} {return}
#   :modify OUTPUT-STATUS :value $ohstatus
   }

#---------------------------------------

proc get-setup-status {} {
   global debug currentversion
   global sortdirpath sortprogram setupstatus dirlisttype
   if {$debug} {puts stderr "get-setup-status: sortdirpath=$sortdirpath"}
   set filepath $sortdirpath/$sortprogram
   set setupstatus "Unknown"
   if {$debug} {puts stderr "  ...check sort program setup status"}
   if {![file exists $filepath]} {
      set setupstatus "Not Compiled"
      if {$debug} {puts stderr "setupdir does not exist: $filepath"}
      return 1
      }
   if {[file exists $filepath/setup_status]} {
      set setupstatus [exec cat $filepath/setup_status]
      if {$debug} {puts stderr "setupdir exists: $filepath, status=$setupstatus"}
       if {[first $setupstatus]==$currentversion} {return 0}
      if {$setupstatus==""} {set setupstatus "Unknown"}
      } \
   else {
      if {$debug} {puts stderr "setupdir exists: $filepath, no setupstatus"}
      set setupstatus "Unknown"
      }
   return 1
   }

proc dirnames l {
   set ll {}
   foreach f $l {lappend ll [first $f]}
   return $ll
   }

proc read-sortprograms {} {
   global debug currentversion
   global sortdirpath sortprogstrings
# improve error for case where directory does not exist
    set a [pwd]
    set z [catch {cd $sortdirpath} m]
    if {$z} {
      display-midas-error-report self $m \
              "Attempting to read directory" $sortdirpath
      error $m
      }
   set z [catch {exec csh -cf "grep -l \"$currentversion\" */setup_status | awk -F\"/\" '{print \$1}'"} m]
   if {$z==0} {set sortprogstrings $m} {set sortprogstrings ""}
   cd $a
   set sortprogstrings [linsert $sortprogstrings 0 <NewSetup>]
}

proc read-runstatus {} {
   global debug
   global sortdirpath sortprogram basedir
   if {$debug} {puts stderr "read-runstatus: '$sortprogram'"}
   if {$sortprogram!=""} {
      set m ""
      set z [mtsort $basedir "s state" m 1]
      if {$z!=0} {
         display-midas-error-report self "" \
                 "Attempting to read run status:\n $m"
         } \
      else {
         case $m in {
            default {:modify RUN-STATUS :value $m}
            }
         }
      }
   }

proc read-options {} {
   global debug autogainstyle basedir passthrough eventpause
   if {$debug} {puts stderr "read-options: '$autogainstyle'"}
   set m ""
   set z [mtsort $basedir "e badpeak ?" m 1]
   if {$z!=0} {
      display-midas-error-report self "" \
              "Unable to read autogain option:\n" $m
      } \
   else {
      set autogainstyle $m
      }

   set m ""
   set z [mtsort $basedir "e setpass ?" m 1]
   if {$z!=0} {
      display-midas-error-report self "" \
              "Unable to read pass through option:\n" $m
      } \
   else {
      set passthrough $m
      }

   set m ""
   set z [mtsort $basedir "s pausemode ?" m 1]
   if {$z!=0} {
      display-midas-error-report self "" \
              "Unable to read pause mode option:\n" $m
      } \
   else {
      set eventpause $m
      }

   }

#------------------------------------------------------------------------------

proc click-sort-program {n} {
   global debug sortprogram sortdirpath basedir sortprogstrings execpid

   frame-busy
   if {$debug} {puts stderr "click-sort-program: $n"}
   set newsortprogram [lindex $sortprogstrings $n]
# check setup status ...
   if {$newsortprogram == "<NewSetup>"} {
       set-footer "Setup new sort program"
       click-setup-frame
       frame-idle
       return
       }
    if {$sortprogram == ""} {
       set sortprogram $newsortprogram
       set basedir $sortdirpath/$sortprogram
       }
   if {$execpid == 0} {
       set sortprogram $newsortprogram
       set basedir $sortdirpath/$sortprogram
       load-exec-task
   }
   set-sort-program $newsortprogram
   frame-idle
   }

proc set-sort-program {newsortprogram} {
   global debug basedir event_change spec_change sortdirpath
   global sortprogram sortprogstrings

# Only allow if stopped ...
   set m ""
   set z [mtsort $basedir "s state" m 1]
   if {$z!=0} {
       set-footer "Cant access scheduler"
       set sortprogram $newsortprogram
       set basedir $sortdirpath/$sortprogram
       set spec_change 1
       set event_change 1
       return
   }
   if {$m == "Going"} {set-footer "Cant change when scheduler going" ; return}
   set-footer "Changing to new sort program ..."
   set sortprogram $newsortprogram
   set basedir $sortdirpath/$sortprogram
   set spec_change 1
   set event_change 1
   set z [mtsort $basedir "s basedir $sortdirpath/$newsortprogram" m 1]
   if {$z!=0} {set-footer "Error setting basedir in scheduler" ; return}
   after 2000
   set z [mtsort $basedir "s dir $sortdirpath/$sortprogram" m 1]
   if {$z!=0} {set-footer "Error in scheduler ($m)" ; frame-idle; return}

   repaint
   clear-footer
   }

set runfilelist ""
proc get-input-runfiles {} {
   global basedir runfilelist
   set runfilelist ""
   set m ""
   set z 0
   set i 0
    while {$z==0} {
	set i [expr $i + 1]
	set z [mtsort $basedir "i runinfo $i ?" m 1]
	if {$z==0} {lappend runfilelist "$m dummy"}
    }
    if {$i == 1} {
	set r "NET NET 1 2147483647"
	set z [mtsort $basedir "i runinfo 1 $r" m 1]
	if {$z!=0} {
	    display-midas-error-report self "" "Error saving runfiles:\n" $m
	    frame-idle
	    return
	}
    }
    return
}

proc set-input-runfiles {} {
    global basedir currentrunfile runfilelist
    frame-busy
    
    set m ""
    set r "NET NET 1 2147483647"

    set z [mtsort $basedir "i runinfo 1 $r" m 1]
    if {$z!=0} {
	display-midas-error-report self "" "Error saving runfiles:\n" $m
	frame-idle
	return
    }
    
    set z [mtsort $basedir "i runinfo 2 $r" m 1]
    if {$z!=0} {
	display-midas-error-report self "" "Error saving runfiles:\n" $m
	frame-idle
	return
    }

    set z [mtsort $basedir "i revoke" m 1]
    if {$z!=0} {
	display-midas-error-report self "" "Error revoking runfile:\n" $m
	frame-idle
	return
    }
    clear-footer
    frame-idle
}

proc set-output-runfiles {stream} {
   global basedir outHandlerEnable
   frame-busy

    if {$outHandlerEnable($stream)} {
	set m ""
	set r "NULL NULL 1 2147483647"
	set z [mtsort $basedir "o runinfo $stream 1 $r" m 1]
	if {$z!=0} {
	    display-midas-error-report self "" "Error saving runfiles:\n" $m
	    frame-idle
	    return
	}
	set z [mtsort $basedir "o runinfo $stream 2 $r" m 1]
	if {$z!=0} {
	    display-midas-error-report self "" "Error saving runfiles:\n" $m
	    frame-idle
	    return
	}
    }
    clear-footer
    set-footer "set-output-runfiles $r"
    frame-idle
   }

proc click-go {} {
   global debug basedir runstate specpath
   global sortprogram setupstatus currentversion specstyle spec_change 
   global ihstatus ohstatus
   if {$debug} {puts stderr "click-go"}

   frame-busy
   clear-footer

   if {$runstate} {
      frame-idle
      repaint
      set-footer "Already going!"
      return
   }

   if {$specpath==""} {
      display-midas-error-report self "" \
              "Cannot run sort\n" "Spectrum path not supplied"
      frame-idle
      return
      }

   get-setup-status
   set z [catch {
      if {$sortprogram==""} \
         {error "no sort program selected"}
       if {[first $setupstatus]!=$currentversion} \
         {error "setup status=$setupstatus"}
      } m]
   if {$z!=0} {
      display-midas-error-report self "" \
              "Cannot run sort program  $sortprogram:\n" $m
      frame-idle
      return
      }

   set status ""
   set z [mtsort $basedir "i state" status 1]
   if {$z==0} {set ihstatus $status}
   if {$z==0 && $status=="Going"} {
      display-midas-error-report self "" \
              "Cannot run sort:\n" "invalid input handler status:" $status
      frame-idle
      return
      }
   set z [mtsort $basedir "o state" status 1]
   if {$z==0} {set ohstatus $status}
   if {$z==0 && $status=="Going"} {
      display-midas-error-report self "" \
              "Cannot run sort:\n" "invalid output handler status:" $status
      frame-idle
      return
      }

   paint-handlers

   if {$specstyle == "new"} {
       confirm "  Delete and recreate spectra? " spec_change_run_sort
      } {
      run-sort
   }

   frame-idle
   return
}

proc spec_change_run_sort {} {
    global spec_change event_change
    set spec_change 1
    set event_change 1
    run-sort
}

proc run-sort {} {
   global debug basedir online remote runstate 
   global spec_change input_change output_change event_change
   global specpath sortdirpath sortprogram specstyle
   global outhandlerlist ohselected outHandlerEnable MAXOUTSTREAMS

   put-sortlog "SORT RUN: ------------------------------------------------------------------"
   set dt [clock format [clock seconds] -format "%a %d %b %T"]
   put-sortlog "$dt  Sort run started for $sortprogram"
   put-sortlog "---------------------------------------------------------------------------"

    if {$spec_change} {
	if {$debug} {puts stderr "Exec MTsortSpecmake: '$sortdirpath' '$sortprogram' '$specstyle' '$specpath'"}
	set-footer "Please wait, Initialising spectra ..."
	set z [catch {
	    exec MTsortSpecmake $sortdirpath $sortprogram $specstyle $specpath} m]
	if {$debug} {
	    puts stderr $m
	    puts stderr "Exec MTsortSpecmake returned $z"
	}
	if {$z} {
	    # Legnaro feature... retry usually works second time!
	    set z2 [catch {
		exec MTsortSpecmake $sortdirpath $sortprogram $specstyle $specpath} m]
	    if {$debug} {
		puts stderr $m
		puts stderr "Exec MTsortSpecmake returned $z"
	    }
	    if {$z2} {
		put-sortlog $m
		display-midas-error-report self "" \
		    "Cannot run sort program  $sortprogram\n" \
		    "error in MTsortSpecmake"
		frame-idle
		return
	    }
	}

    }

    clear-footer
    set m ""
    set z [mtsort $basedir "s specdir $specpath" m 1]
    if {$z} { set-footer $m; frame-idle; return}

    if {[file exists $sortdirpath/$sortprogram/.mapfiles]} {
       set mappath $specpath/maps
       if {![file exists $mappath]} {file mkdir $mappath}
       if {![file exists $mappath/.mapsbuilt]} {
          set-footer "Please wait, generating maps ..." 
	   put-sortlog "Generating maps in $mappath ..." 
	   set z [catch {exec MTmapmake -d$mappath < $sortdirpath/$sortprogram/mapinfo} result]
           put-sortlog "$result returned $z "
	   if {$z} { set-footer $m; frame-idle; return}
           catch {exec echo $mappath > $mappath/.mapsbuilt}
       }
    }

    inform soo send-output-style

    if {$input_change} {
	set z [load-input-handler]
	if {$z} { set-footer $m; frame-idle; return}
        set input_change 0
    }

    if {$output_change} {
	for {set stream 1} {$stream <= $MAXOUTSTREAMS} {incr stream} {
	    if {$outHandlerEnable($stream)} {
		set z [load-output-handler $stream]
		if {$z} { set-footer $m; frame-idle; return}
	    }
	}
        set output_change 0
    }

    if {$event_change || $spec_change} {
	set m ""
	set prog $sortdirpath/$sortprogram/MTsortEvent
	set z [mtsort $basedir "e load $prog" m 120]
	if {$z} { set-footer $m; frame-idle; return}
        set event_change 0
    }

    set spec_change 0

   frame-idle

   set z [mtsort $basedir "s run" m 120]
   if {$z} { set-footer $m; frame-idle; return}

   set runstate 1

    for {set stream 1} {$stream <= $MAXOUTSTREAMS} {incr stream} {
	if {$outHandlerEnable($stream)} {
	    set h [lindex $outhandlerlist $ohselected($stream)]
	    if {$h == "Null"} {set-output-runfiles $stream}
	}
    }
   if {$online || $remote} {set-input-runfiles}

   set m ""
   set z [mtsort $basedir "s go" m 30]
   if {$z} { set-footer $m }
   repaint
   frame-idle
}

proc click-stop {} {
   global debug basedir runstate
   if {$debug} {puts stderr "click-stop"}
   set runstate 0
   set m ""
   set z [mtsort $basedir "s stop" m 30]
   if {$z} { set-footer $m }
   repaint
}

proc click-pause {} {
   global debug basedir runstate
   if {$debug} {puts stderr "click-pause"}
   set m ""
   set z [mtsort $basedir "e pause" m 30]
   if {$z} { set-footer $m }
   repaint
}

proc click-resume {} {
   global debug basedir runstate
   if {$debug} {puts stderr "click-resume"}
   set m ""
   set z [mtsort $basedir "e resume" m 30]
   if {$z} { set-footer $m }
   repaint
}

proc click-reload {} {
   global debug basedir so_mtime spec_change MAXOUTSTREAMS
   if {$debug} {puts stderr "click-reload"}
   unload-exec-task

    set new_mtime [file mtime $basedir/MTsortEvent.so]
    if {$so_mtime != ""} {
	if {$new_mtime > $so_mtime} {
	    set spec_change 1
	}
    }
   load-exec-task
}

proc click-sortexit {} {
   global debug specpath
   if {$debug} {puts stderr "click-exit"}
   unload-exec-task
}

proc click-exit {} {
   global debug specpath
   if {$debug} {puts stderr "click-exit"}
#   unload-exec-task
   if {$specpath != ""} {click-delete-spectra}
   DeleteTask
}

proc finish {} {
   global started
#   unload-exec-task
   set started 0
}

proc click-input-handler {n} {
   global debug basedir input-handler-change
   global ihstatus ihselected inhandlerlist inhandlerprefix
   if {$debug} {puts stderr "click-input-handler: n=$n"}
# Only allow if stopped ...
   set status ""
   set z [mtsort $basedir "i state" status 1]
   if {$z==0} {set ihstatus $status} \
	      else {set ihstatus Unknown}
#   :modify INPUT-HANDLER-STATUS :value $ihstatus

   if {$z!=0} {set-footer "Error accessing scheduler!"; return}
   if {$status == "Going"} {set-footer "Only allowed if stopped!"; return}

   set h $inhandlerprefix[lindex $inhandlerlist $n]
   set z [mtsort $basedir "i handler $h" m 1]
   if {$z} { set-footer "Error setting input handler!"; return }
   set ihselected $n
    [:path INPUT-HANDLER].message configure -text [lindex $inhandlerlist $ihselected]
   set input-handler-change 1
   saveinhandler [lindex $inhandlerlist $n]
   check-input-handler-inits [lindex $inhandlerlist $n]
}

proc load-input-handler {} {
   global debug basedir
   global ihselected
   global inhandlerlist inhandlerprefix
   set h [lindex $inhandlerlist $ihselected]
   if {$debug} {puts stderr "load-input-handler: h=$h"}
   set m ""
   set z [mtsort $basedir "i load $inhandlerprefix$h" m 1]
   if {$z} {set-footer "Error loading handler!"; return}

   saveinhandler $h
   check-input-handler-inits $h
   }

proc click-input-handler-setup {} {
   global debug
   global inhandlerlist ihselected
   if {$debug} {puts stderr "click-input-handler-setup"}
   set handlername [lindex $inhandlerlist $ihselected]
   if {$debug} {puts stderr "...handlername=$handlername"}
   if {$handlername==""} {
      display-midas-error-report self "" "No input handler selected\n" \
              "Choose handler before entering setup"
      } \
   else {
      inform soi start
      }
   repaint
   }

proc click-output-handler {w n} {
   global debug basedir
   global ohstatus ohselected outhandlerlist outhandlerprefix
    set stream [string range $w end end]
   if {$debug} {puts stderr "click-output-handler: stream=$stream n=$n"}

# Only allow if stopped ...
   set status ""
   set z [mtsort $basedir "s state" status 1]
   if {$z==0} {set ohstatus $status} \
	      else {set ohstatus Unknown}
#   :modify OUTPUT-STATUS :value $ohstatus

   if {$z!=0} {set-footer "Error accessing scheduler!"; return}
   if {$status == "Going"} {set-footer "Only allowed if stopped!"; return}

   set h $outhandlerprefix[lindex $outhandlerlist $n]
   set z [mtsort $basedir "o handler $stream $h" m 1]
   if {$z} { set-footer "Error setting output handler!"; return }
   set ohselected($stream) $n
   saveouthandler $stream $h
   set-output-handler-enable $stream
   }

proc load-output-handler {stream} {
   global debug basedir
   global ohselected
   global outhandlerlist outhandlerprefix

    if {$debug} {puts "load-output-handler: stream $stream"}

   set h [lindex $outhandlerlist $ohselected($stream)]
   set m ""
   set z [mtsort $basedir "o load $stream $outhandlerprefix$h" m 1]
   if {$z} {return}

    saveouthandler $stream $h
   }

proc click-output-handler-setup {arg} {
   global debug outhandlerlist ohselected
   if {$debug} {puts stderr "click-output-handler-setup"}
    set stream [string range $arg end end]
   if {$debug} {puts stderr "...outhandlerlist=$outhandlerlist, ohselected=$ohselected($stream)"}

   set handlername [lindex $outhandlerlist $ohselected($stream)]
   if {$debug} {puts stderr "...handlername=$handlername"}
   if {$handlername==""} {
      display-midas-error-report self "" "No output handler selected\n" \
              "Choose handler before entering setup"
      } \
   else {
      inform soo start $stream
      }
   repaint
   }

proc set-output-handler-enable {stream} {
    global debug basedir ohselected outhandlerlist outHandlerEnable
    set n $ohselected($stream)
    set h [lindex $outhandlerlist $n]
    if {$h == "Null"} {set v 0} {set v 1}
    set $outHandlerEnable($stream)  $v
    set z [mtsort $basedir "o stream $stream $v" m 1]
}

proc send-output-handler-enable {stream} {
    global debug basedir outHandlerEnable
    set v $outHandlerEnable($stream)
    set z [mtsort $basedir "o stream $stream $v" m 1]
}

proc click-output-handler-enable {w v} {
    global debug basedir outHandlerEnable 
    set stream [string range $w end end]
    if {$debug} {puts stderr "click-output-handler-enable $stream $v"}

    set outHandlerEnable($stream) $v
    send-output-handler-enable $stream
}

proc click-autogain-option {n} {
   global debug
   global basedir autogainstyle autogainchoices
   if {$debug} {puts stderr "click-autogain-option: n=$n"}
   set autogainstyle $n
   set m ""
   set z [mtsort $basedir "e badpeak $n" m 1]
   }

proc click-setup-frame {} {
   inform sos start
   }

proc click-spectrum-path {e} {
   global debug frame specpath env spec_change event_change
   if {$debug} {puts stderr "click-spectrum-path: specpath=$e"}
   if {$e != $specpath} {set spec_change 1}
   set specpath [file nativename $e]
   set env(SORTSPECPATH) $specpath
   set-eg-option mtsort-spectrum-path $specpath
   edit-defaults mtsort-spectrum-path "set-eg-option mtsort-spectrum-path $specpath"
   }

proc click-spectrum-option v {
   global debug
   global specstyle
    if {$debug} {puts stderr "click-spectrum-option: $v"}
    if {$v==2} {set specstyle "continue"}
    if {$v==1} {set specstyle "old"}
    if {$v==0} {set specstyle "new"}
    if {$debug} {puts stderr "...specstyle=$specstyle"}
}

proc click-passthrough-option v {
   global debug passthrough
   if {$debug} {puts stderr "click-passthrough-option: $v"}
   set passthrough $v
   if {$debug} {puts stderr "...passthrough=$passthrough"}
   
   setpass $passthrough
   }

proc click-pause-option v {
   global debug basedir eventpause
   if {$debug} {puts stderr "click-pause-option: $v"}
   set eventpause $v
   if {$debug} {puts stderr "...eventpause=$eventpause"}
   
   frame-busy
   set m ""
   set z [mtsort $basedir "s pausemode $v" m 1]
   set-footer $m
   frame-idle
   }

proc click-keepwindow-option v {
   global debug keepwindow basedir
   if {$debug} {puts stderr "click-keepwindow-option: $v"}
   set keepwindow $v
   if {$debug} {puts stderr "...keepwindow=$keepwindow"}
   
    if {$keepwindow} {catch {exec rm -f $basedir/.zapwindow}} {exec touch $basedir/.zapwindow} 
   }

proc click-save-spectra {} {
   global debug
   global sortdirpath sortprogram specpath
   if {$debug} {puts stderr "click-save-spectra"}
   frame-busy
   clear-footer
   if {$specpath == ""} {set specpath $env(HOME)}
   set z [catch {exec MTssascopy <$sortdirpath/$sortprogram/specinfo -p$specpath -ssort -w} m]
   if {$z!=0} {
      puts stderr "Spectrum save error ..."
      puts stderr $m
      }
   frame-idle
   }

proc click-delete-spectra {} {
   global debug specpath
   if {$debug} {puts stderr "click-delete-spectra"}
    if {$specpath != ""} {
	confirm "  Delete shared memory spectrum segments for $specpath ? " do-delete-spectra
        }
    }

proc do-delete-spectra {} {
   global specpath
   frame-busy
   clear-footer
#   set z [catch {exec MTssascopy -p$specpath -ssort -r -z} m]
    set z [catch {eg "(spectrum :name '/sort/$specpath/DeleteAll' !delete)"} m]
   if {$z!=0} {
      puts stderr "Spectrum delete error ..."
      puts stderr $m
      }
   frame-idle
   }

proc click-display-spectra {} {
   global debug
   if {$debug} {puts stderr "click-display-spectra"}
   frame-busy
   clear-footer
   inform sb sortstart 1
   frame-idle
   }

proc click-statistics-footer {} {
   global debug
   global basedir
   if {$debug} {puts stderr "click-statistics"}
   frame-busy

   set m ""
   set z [mtsort $basedir "e stats" m 1]
   set-footer $m

   frame-idle
   }

proc click-statistics-window {} {
   global debug
   global basedir
   if {$debug} {puts stderr "click-statistics"}
    clear-footer
   inform sost start $basedir
   }

proc click-zero-statistics {} {
   global debug
   global basedir
   if {$debug} {puts stderr "click-zero-statistics"}
   frame-busy

   set m ""
   set z [mtsort $basedir "e zerostats" m 1]
   set-footer $m

   frame-idle
   }

proc setpass {v} {
   global debug
   global basedir
   if {$debug} {puts stderr "setpass $v"}
   frame-busy

   set m ""
   set z [mtsort $basedir "e setpass $v" m 1]
   set-footer $m

   frame-idle
   }

proc click-print-block {s} {
   global debug
   global basedir
   global printblockmenustrings
   if {$debug} {puts stderr "click-print-block: $s"}
   frame-busy

   set x [second $s]
    if {$x  != "formatted"} {
	set y [string range [first $s] 0 0]
	if {$debug} {puts stderr "...choice=$y $x"}
	set m ""
	set z [mtsort $basedir "$y block $x" m 5]
	if {$z!=0} { set-footer $m }
    } {
	if {[first $s] == "input:"} {set t input} {set t output}
	show-formatted-events $t
    }
   frame-idle
   }

proc click-debug {s} {
   global debug
   global basedir debugmenustrings
   if {$debug} {puts stderr "click-debug: $s"}
   frame-busy
 
   set x [lsearch $debugmenustrings $s]
   if {$debug} {puts stderr "...choice=$x"}
   if {$x < 0} {set x 0}
   if {$x < 6} {
       set m ""
       set z [mtsort $basedir "e trace $x" m 1]
   } else {
	  if {$x < 7} {
	      set m ""
	      set z [mtsort $basedir "s trace 5" m 1]
	  } {
	      set m ""
	      set z [mtsort $basedir "s trace 0" m 1]
	  }
      }
   if {$z!=0} { set-footer $m }

   frame-idle
   }

proc click-spectra {s} {
   global debug
   global basedir spectramenustrings
   if {$debug} {puts stderr "click-spectra: $s"}
 
   set x [lsearch $spectramenustrings $s]
   if {$debug} {puts stderr "...choice=$x"}

  case $x {
      {0} {click-save-spectra}
      {1} {click-delete-spectra}
      default {set-footer "Invalid option"}
      }
   }

proc click-show-sortlog {s} {
   global debug sortlogmenustrings sortlogmenuvalues
   global sortdirpath sortprogram complist_format 
   if {$debug} {puts stderr "click-show-sortlog: $s"}
   frame-busy
   clear-footer

   set x [lsearch $sortlogmenustrings $s]
   set v [lindex $sortlogmenuvalues $x]
   if {$debug} {puts stderr "...choice=$x value $v"}


   set fulldirname $sortdirpath/$sortprogram
   if {![file exists $fulldirname/sortlog]} {
      set-footer "Sort program $sortprogram does not have sortlog file"
      frame-idle
      return
      }

    if {!$v} {
	put-sortlog "[exec cat $fulldirname/sortlog]" 
    } {
	put-sortlog "[exec tail -$v $fulldirname/sortlog]"
    }
   set-footer "Sortlog for $sortprogram"

   frame-idle
   }

proc put-sortlog text {
   :modify SORTLOG :append T :strings "$text\n" :see end
   }

proc show-formatted-events {type} {
   global sortdirpath sortprogram eventlisting
   frame-busy
   clear-footer
   set fulldirname $sortdirpath/$sortprogram
   if {![file exists $fulldirname/adcwords]} {
      display-midas-error-report self "" \
              "Sort program $sortfile does not have adc words listing"
      frame-idle
      return
      }
    if {$type == "output"} {set option "-o"} {set option ""}
    set z [catch {exec MTsortShmEventDump $option $fulldirname} eventlisting]
    if {!$z} { 
   make-formatted-events-frame $eventlisting "Formatted Events listing for $sortprogram"
    }
    frame-idle
   }

proc click-dismiss-formatted-events {} {
   destroy [self frame-name].formevents
}

proc click-print-formatted-events {} {
    global eventlisting
    print-listing $eventlisting
}

proc midas-save-window {window} {
   upvar #0 browserdirectory directory
   upvar #0 browserfile file

   set z [catch {open $directory/$file w} f]
   if {$z != 0} {midas-warning "Unable to write $directory/$file\n$f"; return}
   puts $f $window
   close $f
}

proc click-save-formatted-events {} {
    global eventlisting
    midas-browser W midas-save-window $eventlisting
}

proc make-formatted-events-frame {list message} {
   global env
   :frame [self frame-name].formevents :transient T :label $message
   :layout B
   :panel BUTTONS  :layout B :padx 120 :pady 10
     :layout H; :row-gap 0; :col-gap 40
    :button DISMISS :label Dismiss
    :button PRINT :label Print
    :button SAVE :label Save
   :panel MAIN  :layout B :padx 0 :pady 0
    :galley LISTING  :rows 30 :cols 80 :deaf T :font fixed
#   [:path LISTING].text configure -font courier
   :modify LISTING :strings $list :see 0
   :show T
}

proc click-help {} {
    global env
   send help html_show {"" $env(MTSORTBASE)/manual/sortrun.html}
   }

# Requires htmlviewer.patch.tcl  to work ...
proc click-help {} {
    global env
    inform htmlviewer startfile $env(MTSORTBASE)/manual/sortrun.html
   }

proc click-refresh {} {
   global debug
   if {$debug} {puts stderr "click-refresh"}
   frame-busy
   read-sortprograms
   read-options
   repaint
   frame-idle
   }

proc click-variables {} {inform sov start}

proc confirm {m action} {
   global debug
   set i [tk_dialog [self frame-name].quitdialog "[self frame-title] Confirmation" $m  "warning" 1 "Cancel" "Confirm"]
   update idletasks
   if {$i} $action
   if {$debug} {puts stderr "confirm: $m choice $i"}
   }

proc extract-handler {h} {
    set a [string first "Tape" $h]
    set b [string first ".so" $h]

    if { $a != -1} {
	set hname [string range $h 0 [expr $a -1]]
	set htype [string range $h $a end]
    } {
	set a [string first "Disc" $h]
	if { $a != -1} {
	    set hname [string range $h 0 [expr $a -1]]
	    set htype [string range $h $a end]
	} {
	    set a [string first "Online" $h]
	    if { $a != -1} {
		set hname [string range $h 0 [expr $a -1]]
		set htype [string range $h $a end]
	    } {
		set a [string first "Remote" $h]
		if { $a != -1} {
		    set hname [string range $h 0 [expr $a -1]]
		    set htype [string range $h $a end]
		} {
		    set a [string first "Null" $h]
		    set hname [string range $h 0 [expr $a -1]]
		    set htype [string range $h $a end]
		}
	    }
	}
    }
    return [list $hname $htype]
}
    
proc check-input-handler-inits {h} {
    global env basedir online

    set online [string match "*Online*" $h]
    set remote [string match "*Remote*" $h]

    if {[file exists $basedir/.mtsort.cf]} {return}


    # Extract handler name ...
 
    set hsplit [extract-handler $h]
    set hname [first $hsplit]

    # Check if handler config file exists ...

    set hs ""
    if {$hname != ""} {
	set lname [string tolower $hname]
	set cfname "$env(MTSORTBASE)/config/$lname.cf"
	if {[file exists $cfname]} {set hs soi-GenericConfig}
    }
    if {$hs == ""} return
    
    set f [set env(MTSORTBASE)]/config/$lname.cf
    set z [catch {exec cp $f $basedir/.mtsort.cf} m]
    if {$z} { set-footer "$hname-init fail: $m"}
    
}

proc setinhandler {} {
    global inhandlerdefault
    set m ""
    set z [catch {get-eg-option mtsort-input-handler} m]
    if {$z} { saveinhandler $inhandlerdefault } {set inhandlerdefault $m}
 
    def-inhandler
}

proc remove-outprefix {h} {
    global outhandlerprefix
    if { [string first $outhandlerprefix $h]==0} {
	set h [string range $h [string length $outhandlerprefix] end]
    }
}

proc setouthandlers {} {
    global outhandlerlist outhandlerdefault MAXOUTSTREAMS

    for {set stream 1} {$stream <= $MAXOUTSTREAMS} {incr stream} {
	set m ""
	set z [catch {get-eg-option mtsort-output-handler$stream} m]
	if {$z} { saveouthandler $stream $outhandlerdefault } {
	    set m [remove-outprefix $m]
	}
	set outhandlerdefault $m
	set ohselected($stream) [lsearch $outhandlerlist $outhandlerdefault]
    }

}

proc startit {} {
   global debug
   global sortdirpath sortprogram
   start $sortdirpath $sortprogram
   }

proc start {path prog} {
   global debug started frame keepwindow
   global sortdirpath sortprogram basedir iloop runstate
   global inhandlerdefault outhandlerdefault
   if {$debug} {
      puts stderr "start: [self frame-name] (started=$started)"
      puts stderr "args... = $path $prog"
      }

    if {$path!=""} {set sortdirpath $path}
    set sortprogram $prog
    set runstate 0
    set z [get-setup-status]
#   if {$z} {return}

    if {$started} {
       bring-to-front [self frame-name]
       read-sortprograms
       set-sort-program $sortprogram
       repaint
    } {
       set basedir $sortdirpath/$sortprogram

      init-sort-frame

       setinhandler
       setouthandlers

      make-frame

      bind all <Shift-KeyPress-F10> {inform rmt start}
      bind all <Control-Alt-KeyPress-Delete> {click-quit [self frame-name]}

      check-processes

      if {$sortprogram != ""} {load-exec-task}
    }

  }

proc unload-exec-task {} {
   global started basedir execpid runstate iloop
    set iloop 0
   set m ""
   set z [mtsort $basedir "s exit" m 10]
   if {$z} {
       set z [catch {set pid [exec cat $basedir/sort-pid]} m]
       if {!$z} {
#	   set z [catch {exec kill -9 $pid} m]
       }
       if {$z} { set-footer $m }
   }

   after 1000
   set z [mtsort $basedir -z m 1]
   if {$z} { set-footer $m }

   set execpid 0

   set runstate 0
}

proc load-exec-task {} {
    global debug env basedir execcomwindow execpid iloop so_mtime

    if {$debug} {puts stderr "Start sort running ..."}
    
    set m ""

    set z [mtsort $basedir -s m 1]
    if {$z} {
	set-footer "Please wait, loading sort control task ..." 
#	set z [catch {exec rm -f $basedir/.key} m]

	set z [catch {eval $execcomwindow} m]
	if {$z} {set-footer $m; return }
	
	set execpid $m
    }

    set so_mtime [file mtime $basedir/MTsortEvent.so]
    
    frame-busy
    set iloop 30
    after 3000 wait-for-status
   
}

proc def-inhandler {} {
   global inhandlerlist ihselected inhandlerdefault
   set ihselected [lsearch $inhandlerlist $inhandlerdefault]
   }

proc def-outhandler {stream} {
   global outhandlerlist ohselected outhandlerdefault
   set ohselected($stream) [lsearch $outhandlerlist $outhandlerdefault]
#    puts "def-outhandler $stream [set ohselected($stream)]"
   }

proc wait-for-status {} {
   global iloop basedir sortdirpath sortprogram handlerdir
   global inhandlerprefix inhandlerdefault outhandlerprefix outhandlerdefault
   global inhandlerlist outhandlerlist outHandlerEnable
   global ihselected ohselected MAXOUTSTREAMS
   global env passthrough keepwindow eventpause

   set iloop [expr "$iloop - 1"]
   set m ""

    set z [mtsort $basedir -s m 1]
   if {$iloop <= 0} \
      {
      set-footer "Sort download timeout: check status"
      frame-idle
      return
      }
   if {$z} { after 1000 wait-for-status }  \
   else  \
      {
      clear-footer
 
      if {$sortprogram!=""} {
         set z [mtsort $basedir "s state" m 1]
         :modify RUN-STATUS :value $m
	  if {$m != "Uninitialised"} {click-refresh; return}
         }

      set m ""
      set z [mtsort $basedir "s libpath $handlerdir" m 1]
      if {$z} { return }
# set dir for programs executed from scheduler
      set z [mtsort $basedir "s binpath $env(MTSORTBASE)/bin$env(MTSORTDIRPOSTFIX)" m 1]

      set z [mtsort $basedir "s dir $basedir" m 1]
      if {$z} { return }
      set z [mtsort $basedir "s log 1" m 1]
      if {$z} { return }

      set z [mtsort $basedir "s ready" m 1]
      if {$z} { return }

      set h $inhandlerprefix[lindex $inhandlerlist $ihselected]
      set z [mtsort $basedir "i handler $h" m 1]
      if {$z} { return }
      check-input-handler-inits $inhandlerdefault

      for {set stream 1} {$stream <= $MAXOUTSTREAMS} {incr stream} {
	  set h $outhandlerprefix[lindex $outhandlerlist $ohselected($stream)]
	  set z [mtsort $basedir "o handler $stream $h" m 1]
	  if {$z} { set-footer "Error setting output handler for stream $stream!"; return }

          read-set-runfiles $stream
          set-output-handler-enable $stream
      }

      set dev ""
      set z [catch {get-eg-option mtsort-input-device1} dev]
      if {!$z} {
	  set z [mtsort $basedir "i stream 1" m 1]
	  set z [mtsort $basedir "i device $dev" m 1]
      }
      
      set stream 1
      set z [catch {get-eg-option mtsort-output-device1} dev]
      if {!$z} {
	  set z [mtsort $basedir "o device $stream $dev" m 1]
      }

      inform soo send-output-style

      set passthrough 0
      :modify PASS-OPTION :value $passthrough

      set eventpause 0
      :modify PAUSE-OPTION :value $eventpause

    click-keepwindow-option $keepwindow

      paint-handlers

      if {$sortprogram!=""} {
         set z [mtsort $basedir "s state" m 1]
         if {$z!=0} { return }
         :modify RUN-STATUS :value $m
         }

      frame-idle
      }
   }

# procedure called by sort spectrum browser to see if sort stopped
# for it to be able to zero spectra safely

proc call-back {interp proc result} {
   global debug
   if {$debug} {puts stderr "[self frame-name]: call-back: $interp $proc $result"}
   send $interp $proc [transparent [$result]]
   }

proc put-sortrunstatus {} {
   global sort_going
   return $sort_going
   }

proc get-sortprogram {} {
   global sortdirpath sortprogram
   return $sortdirpath/$sortprogram
   }

proc get-sortdir {} {
   global sortdirpath
   return $sortdirpath
   }

proc get-handlerdir {} {
    global handlerdir
    return $handlerdir
}

#-- spectrum resource list ------------
proc is-spec-server-resource ps {
  foreach p $ps {
      case [first $p] in {
         name {set name [second $p]}
         host {set host [second $p]}
         port {set port [second $p]}
         type {set type [second $p]}
         role {set role [second $p]}
         apparatus {set app [second $p]}
         ipaddress {set ipaddress [second $p]}
         capability {set cap [second $p]}
         flags {set flags [second $p]}
         default {} 
         }
      }
  if { $type=="spectrum" && [string match "\[0\]*" $cap]} {
    return $role
    } \
  else {
    return ""
    }
  }

proc make-spec-resource-list rs {
   global debug
   set ll {}
   foreach r $rs {
      set rget [is-spec-server-resource $r]
      if {$debug} {puts stderr "...rget=$rget"}
      if {[llength $rget]!=0} {lappend ll $rget}
      }
   if {$debug} {puts stderr "resource list=$ll"}
   return $ll
   }

#---------------------------------------

tk_focusFollowsMouse

loadsource mtsortcommand