#########################################################################
#									#
#	MIDAS General sort package					#
#									#
#	File:		sol.tcl (sort launch on remote machine)		#
#									#
#	Author(s):	Janet Sampson/John Cresswell			#
#									#
#	Last revision:	3/10/97						#
#									#
#########################################################################

set frame SOL
set frametitle "MTsort Launcher"
set icontitle "Launcher"

#set sortmachine [exec uname -n]
set sortmachine eb08
set thismachine [exec uname -n]

proc click arg {
   global debug

   if {$debug} then {insert-debug "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch $w {

       MACHINE   {click-machine $v}
       LAUNCH    {click-launch}
       KILL      {click-kill}
       MYHELP      {click-help}
       default   {}
   }
}

proc make-frame {} {
    global sortmachine
  :set footer_position center
  :frame [self frame-name] :label "[self frame-title]" :show-footer T  \
    :icon-name "[self icon-title]"

  :panel PANEL1 :layout T :padx 10 :pady 10
   :layout H; :row-gap 10
    :text MACHINE   :label "Sort machine" :w 20 :value "$sortmachine"

  :panel PANEL2 :layout T  :padx 10
    :layout H; :col-gap 20
    :button LAUNCH  :label "Launch session"
    :button KILL  :label "Kill session"
    :next-row T
    :button MYHELP  :command click-help :x 162
  :show T

  bind all <Shift-KeyPress-F10> {inform rmt start}

  bind all <Control-Alt-KeyPress-Delete> {click-quit [self frame-name]}

}

proc redisplay {} {make-frame}

proc click-machine {m} {
    global sortmachine 
    set sortmachine $m
}

proc click-launch {} {
    global sortmachine thismachine
    frame-busy
    if {$sortmachine == $thismachine} {
	inform sos start
    } {
	exec xhost +$sortmachine
        exec /bin/rsh -l euroball $sortmachine mtsort-run $thismachine $sortmachine &
    }
    frame-idle
}

proc click-kill {} {
    global sortmachine thismachine
    frame-busy
    if {$sortmachine == $thismachine} {
	inform soc click-exit
	inform sos DeleteTask
    } {
	set m ""
	set z [catch {exec rsh -l euroball $sortmachine killMTsort} m]
        puts $m
    }
    frame-idle
}

proc click-help {} {
    send help html_show {"" $env(MTSORTBASE)/manual/MTsort.html}
   }

# Requires htmlviewer.patch.tcl  to work ...
proc click-help {} {
    global env
    inform htmlviewer startfile $env(MTSORTBASE)/manual/MTsort.html
   }

proc finish {} {
    global sortmachine thismachine
    if {$sortmachine != $thismachine} {
	exec rsh -l euroball $sortmachine killMTsort
    }

   }
